HDU 1698 Just a Hook(线段树lazy成段更新)

Just a Hook

Problem Description

In the game of DotA, Pudge’s meat hook is actually the most horrible thing for most of the heroes. The hook is made up of several consecutive metallic sticks which are of the same length.

Now Pudge wants to do some operations on the hook.

Let us number the consecutive metallic sticks of the hook from 1 to N. For each operation, Pudge can change the consecutive metallic sticks, numbered from X to Y, into cupreous sticks, silver sticks or golden sticks.
The total value of the hook is calculated as the sum of values of N metallic sticks. More precisely, the value for each kind of stick is calculated as follows:

For each cupreous stick, the value is 1.
For each silver stick, the value is 2.
For each golden stick, the value is 3.

Pudge wants to know the total value of the hook after performing the operations.
You may consider the original hook is made up of cupreous sticks.

Input

The input consists of several test cases. The first line of the input is the number of the cases. There are no more than 10 cases.
For each case, the first line contains an integer N, 1<=N<=100,000, which is the number of the sticks of Pudge’s meat hook and the second line contains an integer Q, 0<=Q<=100,000, which is the number of the operations.
Next Q lines, each line contains three integers X, Y, 1<=X<=Y<=N, Z, 1<=Z<=3, which defines an operation: change the sticks numbered from X to Y into the metal kind Z, where Z=1 represents the cupreous kind, Z=2 represents the silver kind and Z=3 represents the golden kind.

Output

For each case, print a number in a line representing the total value of the hook after the operations. Use the format in the example.

Sample Input

1

10

2

1 5 2

5 9 3

Sample Output

Case 1: The total value of the hook is 24.

  1 #include<cstdio>
  2 using namespace std;
  3
  4 const int maxn=100050;
  5 int sum[maxn<<2];
  6 int add[maxn<<2];
  7
  8 struct node
  9 {
 10     int l,r;
 11 }tree[maxn<<2];
 12
 13 void PushUp(int rt)
 14 {
 15     sum[rt]=sum[rt<<1]+sum[rt<<1|1];
 16 }
 17
 18 void PushDown(int rt,int m)
 19 {
 20     if(add[rt])
 21     {
 22         add[rt<<1]=add[rt];
 23         add[rt<<1|1]=add[rt];
 24         sum[rt<<1]=add[rt]*(m-(m>>1));
 25         sum[rt<<1|1]=add[rt]*(m>>1);
 26         add[rt]=0;
 27     }
 28 }
 29
 30
 31 void build(int l,int r,int rt)
 32 {
 33     tree[rt].l=l;
 34     tree[rt].r=r;
 35     add[rt]=0;
 36     if(l==r)
 37     {
 38         sum[rt]=1;
 39         return;
 40     }
 41     int mid=(r+l)>>1;
 42     build(l,mid,rt<<1);
 43     build(mid+1,r,rt<<1|1);
 44     PushUp(rt);
 45 }
 46
 47 void update(int t,int l,int r,int rt)
 48 {
 49     if(tree[rt].l==l&&tree[rt].r==r)
 50     {
 51         add[rt]=t;
 52         sum[rt]=t*(r-l+1);
 53         return;
 54     }
 55     if(tree[rt].l==tree[rt].r)return;
 56     PushDown(rt,tree[rt].r-tree[rt].l+1);
 57     int mid=(tree[rt].r+tree[rt].l)>>1;
 58     if(r<=mid)update(t,l,r,rt<<1);
 59     else if(l>mid)update(t,l,r,rt<<1|1);
 60     else
 61     {
 62         update(t,l,mid,rt<<1);
 63         update(t,mid+1,r,rt<<1|1);
 64     }
 65     PushUp(rt);
 66 }
 67
 68 int query(int l,int r,int rt)
 69 {
 70     if(l==tree[rt].l&&r==tree[rt].r)
 71     {
 72         return sum[rt];
 73     }
 74     PushDown(rt,tree[rt].r-tree[rt].l+1);
 75     int mid=(tree[rt].l+tree[rt].r)>>1;
 76     int ans=0;
 77     if(r<=mid)ans+=query(l,r,rt<<1);
 78     else if(l>mid)ans+=query(l,r,rt<<1|1);
 79     else
 80     {
 81         ans+=query(l,mid,rt<<1);
 82         ans+=query(mid+1,r,rt<<1|1);
 83     }
 84     return ans;
 85 }
 86
 87 int main()
 88 {
 89     //freopen("in.txt","r",stdin);
 90     int i,t,a,b,val,n,m;
 91     scanf("%d",&t);
 92     for(i=1;i<=t;i++)
 93     {
 94         scanf("%d",&n);
 95         build(1,n,1);
 96         scanf("%d",&m);
 97         while(m--)
 98         {
 99             scanf("%d%d%d",&a,&b,&val);
100             update(val,a,b,1);
101         }
102         int ans=query(1,n,1);
103         printf("Case %d: The total value of the hook is %d.\n",i,ans);
104     }
105     return 0;
106 }
时间: 2024-08-24 15:46:18

HDU 1698 Just a Hook(线段树lazy成段更新)的相关文章

hdu 1698 Just a Hook(线段树,成段更新,懒惰标记)

Just a Hook Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 18384    Accepted Submission(s): 9217 Problem Description In the game of DotA, Pudge's meat hook is actually the most horrible thing

HDU 1698 Just a Hook (线段树 成段更新 lazy-tag思想)

题目链接 题意: n个挂钩,q次询问,每个挂钩可能的值为1 2 3,  初始值为1,每次询问 把从x到Y区间内的值改变为z.求最后的总的值. 分析:用val记录这一个区间的值,val == -1表示这个区间值不统一,而且已经向下更新了, val != -1表示这个区间值统一, 更新某个区间的时候只需要把这个区间分为几个区间更新就行了, 也就是只更新到需要更新的区间,不用向下更新每一个一直到底了,在更新的过程中如果遇到之前没有向下更新的, 就需要向下更新了,因为这个区间的值已经不统一了. 其实这就

HDU 1698 Just a Hook 线段树解法

很经典的题目,而且是标准的线段树增加lazy标志的入门题目. 做了好久线段树,果然是practice makes perfect, 这次很畅快,打完一次性AC了. 标志的线段树函数. 主要是: 更新的时候只更新到需要的节点,然后最后的时候一次性把所以节点都更新完毕. 这也是线段树常用的技术. #include <stdio.h> const int SIZE = 100005; struct Node { bool lazy; int metal; }; const int TREESIZE

HDU 1698 Just a Hook(线段树区间替换)

题目地址:HDU 1698 区间替换裸题.同样利用lazy延迟标记数组,这里只是当lazy下放的时候把下面的lazy也全部改成lazy就好了. 代码如下: #include <iostream> #include <cstdio> #include <string> #include <cstring> #include <stdlib.h> #include <math.h> #include <ctype.h> #in

HDU 1698 Just a Hook (线段树,区间更新)

Just a Hook Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 17214    Accepted Submission(s): 8600 Problem Description In the game of DotA, Pudge’s meat hook is actually the most horrible thing f

hdu 1698 Just a Hook(线段树之 成段更新)

Just a Hook                                                                             Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Problem Description In the game of DotA, Pudge's meat hook is actually the mos

hdu1698 Just a Hook 线段树:成段替换,总区间求和

转载请注明出处:http://blog.csdn.net/u012860063 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1698 Problem Description In the game of DotA, Pudge's meat hook is actually the most horrible thing for most of the heroes. The hook is made up of several consecut

POJ 3468-A Simple Problem with Integers(线段树:成段更新,区间求和)

A Simple Problem with Integers Time Limit: 5000MS   Memory Limit: 131072K Total Submissions: 62228   Accepted: 19058 Case Time Limit: 2000MS Description You have N integers, A1, A2, ... , AN. You need to deal with two kinds of operations. One type of

NYOJ 1068 ST(线段树之 成段更新+区间求和)

ST 时间限制:1000 ms  |  内存限制:65535 KB 难度:1 描述 "麻雀"lengdan用随机数生成了后台数据,但是笨笨的他被妹纸的问题给难住了... 已知lengdan生成了N(1=<N<=10005)个随机整数,妹子对这些数可能有以下几种操作或询问: 1,A a b c 表示给区间a到b内每个数都加上c: 2,S a b  表示输出区间a到b内的和: 3,Q a b 表示区间a到b内的奇数的个数: 为了使妹纸不口渴,所以我们决定妹纸的询问次数少一点,即